# Enum Class DataSeries

java.lang.Object
java.lang.Enum<DataSeries>
htsjdk.samtools.cram.structure.DataSeries

All Implemented Interfaces:
  `Serializable, Comparable<DataSeries>, Constable`

public enum DataSeries extends Enum<DataSeries>
Represents a specific CRAM record data series and its associated type and unique Content ID. The content id for a data series is not prescribed by the CrAM spec, so the ids used here represent the ID used by this implementation on write. On read, the ID for each data series must be discovered by interrogating the encoding map.

## Nested Class Summary

### Nested classes/interfaces inherited from class Enum

`Enum.EnumDesc<E>`

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`AP_AlignmentPositionOffset`
`BA_Base`
`BB_Bases`
`BF_BitFlags`
`BS_BaseSubstitutionCode`
`CF_CompressionBitFlags`
`DL_DeletionLength`
`FC_FeatureCode`
`FN_NumberOfReadFeatures`
`FP_FeaturePosition`
`HC_HardClip`
`IN_Insertion`
`MF_MateBitFlags`
`MQ_MappingQualityScore`
`NF_RecordsToNextFragment`
`NP_NextFragmentAlignmentStart`
`NS_NextFragmentReferenceSequenceID`
`PD_padding`
`QQ_scores`
`QS_QualityScore`
`RG_ReadGroup`
`RI_RefId`
`RL_ReadLength`
`RN_ReadName`
`RS_RefSkip`
`SC_SoftClip`
`TC_TagCount`
`TL_TagIdList`
`TM_TestMark`
`TN_TagNameAndType`
`TS_InsertSize`
`TV_TestMark`

## Method Summary

Modifier and Type
Method
Description
`static DataSeries`
`byCanonicalName(String dataSeriesAbbreviation)`
Return the DataSeries associated with the two-character canonical name
`String`
`getCanonicalName()`
`Integer`
`getExternalBlockContentId()`
The content id for a data series is not prescribed by the CrAM spec, so the ids used here represent the ID used by this implementation on write.
`DataSeriesType`
`getType()`
`static DataSeries`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static DataSeries[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods inherited from class Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class Object

`getClass, notify, notifyAll, wait, wait, wait`

## Enum Constant Details

### BF_BitFlags

public static final DataSeries BF_BitFlags

### CF_CompressionBitFlags

public static final DataSeries CF_CompressionBitFlags

### RI_RefId

public static final DataSeries RI_RefId

### RL_ReadLength

public static final DataSeries RL_ReadLength

### AP_AlignmentPositionOffset

public static final DataSeries AP_AlignmentPositionOffset

### RG_ReadGroup

public static final DataSeries RG_ReadGroup

### RN_ReadName

public static final DataSeries RN_ReadName

### NF_RecordsToNextFragment

public static final DataSeries NF_RecordsToNextFragment

### MF_MateBitFlags

public static final DataSeries MF_MateBitFlags

### NS_NextFragmentReferenceSequenceID

public static final DataSeries NS_NextFragmentReferenceSequenceID

### NP_NextFragmentAlignmentStart

public static final DataSeries NP_NextFragmentAlignmentStart

### TS_InsertSize

public static final DataSeries TS_InsertSize

### TL_TagIdList

public static final DataSeries TL_TagIdList

### TC_TagCount

public static final DataSeries TC_TagCount

### TN_TagNameAndType

public static final DataSeries TN_TagNameAndType

### MQ_MappingQualityScore

public static final DataSeries MQ_MappingQualityScore

### FN_NumberOfReadFeatures

public static final DataSeries FN_NumberOfReadFeatures

### FP_FeaturePosition

public static final DataSeries FP_FeaturePosition

### FC_FeatureCode

public static final DataSeries FC_FeatureCode

### BB_Bases

public static final DataSeries BB_Bases

### QQ_scores

public static final DataSeries QQ_scores

### BA_Base

public static final DataSeries BA_Base

### QS_QualityScore

public static final DataSeries QS_QualityScore

### BS_BaseSubstitutionCode

public static final DataSeries BS_BaseSubstitutionCode

### IN_Insertion

public static final DataSeries IN_Insertion

### DL_DeletionLength

public static final DataSeries DL_DeletionLength

### RS_RefSkip

public static final DataSeries RS_RefSkip

### SC_SoftClip

public static final DataSeries SC_SoftClip

### PD_padding

public static final DataSeries PD_padding

### HC_HardClip

public static final DataSeries HC_HardClip

### TM_TestMark

public static final DataSeries TM_TestMark

### TV_TestMark

public static final DataSeries TV_TestMark

## Method Details

### values

public static DataSeries[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static DataSeries valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null

### getType

public DataSeriesType getType()

### getCanonicalName

public String getCanonicalName()

### getExternalBlockContentId

public Integer getExternalBlockContentId()
The content id for a data series is not prescribed by the CrAM spec, so the ids used here represent the ID used by this implementation on write. On read, the ID for each data series must be discovered by interrogating the encoding map.

Returns:
  content ID used when writing a CRAM

### byCanonicalName

public static DataSeries byCanonicalName(String dataSeriesAbbreviation)
Return the DataSeries associated with the two-character canonical name

Parameters:
  `dataSeriesAbbreviation` - A Data Series canonical name, such as QS for Quality Score
Returns:
  the associated DataSeries
Throws:
  `CRAMException` - for an unknown Data Series